import pandas as pd
from datetime import date, datetime
from typing import List, Literal, Union, NewType

DateFormat = NewType(name="%d-%m-%Y", tp=str)
DateFormat_2 = NewType(name="%Y%m%d", tp=str)
DateFormat_3 = NewType(name="%d%b%Y", tp=str)

def mcx_bhavcopy(bhavdate: Union[DateFormat, datetime, date]) -> pd.DataFrame: ...
def mcx_marketwatch() -> pd.DataFrame: ...
def mcx_circulars(from_date: Union[DateFormat, datetime, date] = ..., to_date: Union[DateFormat, datetime, date] = ...) -> pd.DataFrame: ...
def mcx_topgainers() -> pd.DataFrame: ...
def mcx_toploosers() -> pd.DataFrame: ...
def mcx_mostactiveoptions() -> pd.DataFrame: ...
def mcx_mostactivecontracts() -> pd.DataFrame: ...
def mcx_heatmap() -> pd.DataFrame: ...
def mcx_optionchain(commodity: Literal['COPPER', 'CRUDEOIL', 'GOLD', 'GOLDM', 'NATURALGAS', 'NICKEL', 'SILVER', 'SILVERM', 'ZINC'], expiry: Union[DateFormat, datetime, date]) -> pd.DataFrame: ...
def mcx_pcr(expirywise: bool = False) -> pd.DataFrame: ...
def mcx_expiry(commodity: Literal['ALUMINI', 'ALUMINIUM', 'COPPER', 'COTTONCNDY', 'CRUDEOIL', 'CRUDEOILM', 'GOLD', 'GOLDGUINEA', 'GOLDM', 'GOLDPETAL', 'KAPAS', 'LEAD', 'LEADMINI', 'MCXBULLDEX', 'MCXENRGDEX', 'MCXMETLDEX', 'MENTHAOIL', 'NATGASMINI', 'NATURALGAS', 'NICKEL', 'SILVER', 'SILVERM', 'SILVERMIC', 'ZINC', 'ZINCMINI'] = "CRUDEOIL", instrument: Literal['option', 'future'] = "option", expirytype: Literal['current', 'next', 'far', 'all'] = "current") -> Union[datetime, List[datetime]]: ...
def mcx_icomdexindices(datatype: Literal['today', 'historical'] = "today", start_date: Union[DateFormat, datetime, date] = None, end_date: Union[DateFormat, datetime, date] = None) -> pd.DataFrame: ...
def mcx_quote(commodity: Literal['ALUMINI', 'ALUMINIUM', 'COPPER', 'COTTONCNDY', 'CRUDEOIL', 'CRUDEOILM', 'GOLD', 'GOLDGUINEA', 'GOLDM', 'GOLDPETAL', 'KAPAS', 'LEAD', 'LEADMINI', 'MCXBULLDEX', 'MCXENRGDEX', 'MCXMETLDEX', 'MENTHAOIL', 'NATGASMINI', 'NATURALGAS', 'NICKEL', 'SILVER', 'SILVERM', 'SILVERMIC', 'ZINC', 'ZINCMINI'], instrument: Literal['option', 'future'], expiry: Union[DateFormat, datetime, date], optiontype: Literal['CE', 'PE'] = None, strikeprice: Union[str, int, float] = None, outputtype: Literal['quote', 'bidask'] = 'quote') -> pd.DataFrame: ...
